------------------------------------------------------------------------------
-- Broker_AlertFrames
-- Author: Yargoro@Arathor-EU
------------------------------------------------------------------------------
local _,ADDON = nil,select(2,...)				--Includes all functions and variables

ADDON = LibStub("AceAddon-3.0"):NewAddon(ADDON,ADDON.name,"AceEvent-3.0")--,"AceTimer-3.0", "AceBucket-3.0")--,"AceHook-3.0")

--<< Include libs >>--
ADDON.L = LibStub("AceLocale-3.0"):GetLocale(ADDON.name)
ADDON.LDB = LibStub:GetLibrary("LibDataBroker-1.1")			--Data Broker
ADDON.QTip = LibStub:GetLibrary("LibQTip-1.0")				--QTip

local L = ADDON.L
local my = UnitName("player")								--player name

local colorRed =    "|cffff0000"
local colorWhite =  "|cffffffff"
local colorBlack =  "|cff000000"
local colorGreen =  "|cff00ff00"
local colorYellow = "|cffffff00"
local colorOrange = "|cffffd100"

function ADDON:OnInitialize()
	ADDON:Debug("OnInitialize:")

	self:RegisterEvent("PLAYER_LOGIN")
	self:RegisterEvent("PLAYER_LOGOUT")

	--Default values
	if (Broker_AlertFrames == nil) then Broker_AlertFrames = {} end

	local defaultsave = 		--default save values
	{
	}

	ADDON.save = Broker_AlertFrames[GetRealmName()] or {}
	
	--creates a new save tableb
	local function newsave(tbl, default)
		if (tbl==nil) then return default end		--if tbl is empty, then return default table/value
		if (next(default)==nil) then return tbl end	--if default is empty, then return tbl
		local result = {}
		for k,v in pairs(default) do
			if (tbl[k]==nil or type(v)=='table') then
				result[k] = newsave(tbl[k], v)	--recursive
			else
				result[k] = tbl[k]
			end
		end
		return result
	end

	ADDON.save = newsave(ADDON.save, defaultsave)

 	-- SLASH_Broker_AlertFrames1 = "/waitforbpcast";
    -- SlashCmdList["Broker_AlertFrames"] =
	-- function(msg)
	-- 	ADDON:Debug("waitforbpcast called")
	--     while(BPMWaitforcast) do
	-- 	ADDON:Debug("wait fopr cast")
	-- 	end
	-- end 	
end
	
local function GetFirstGarrisonMission(...)
	local missions = {}
	
	for i = 1, select("#", ...) do
		local followerType = select(i, ...)
		
		C_Garrison.GetCompleteMissions(missions, followerType)
		
		if missions[1] then
			return missions[1].missionID
		end
		
		C_Garrison.GetAvailableMissions(missions, followerType)
		
		if missions[1] then
			return missions[1].missionID
		end
	end
end

local function GetFirstShipyardFollowerID(...)
	local numFollowers = C_Garrison.GetNumFollowers(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
	ADDON:Debug("numFollowers:"..numFollowers)
	if numFollowers < 0 then return nil end
	local followers = C_Garrison.GetFollowers()
	return followers[1].followerID
end
	
local handledAlerts =
{
	["GuildChallengeAlertSystem"]=
	{
		["bgname"] = "Interface\\LootFrame\\LootToast",
		["bgcoords"] = {0.56347656,0.80664063,0.28906250,0.56640625},
		["testfunc"] = function() return "GuildChallengeAlertSystem:AddAlert(3, 2, 5)" end
	},
	["DungeonCompletionAlertSystem"]= {},
	["ScenarioAlertSystem"]= {},
	["InvasionAlertSystem"]= {},
	["DigsiteCompleteAlertSystem"]= {},
	["StorePurchaseAlertSystem"]= {},
	["GarrisonBuildingAlertSystem"]= {},
	
	["GarrisonMissionAlertSystem"]=
	{
		["bgname"] = "Interface\\Garrison\\GarrisonToast",
		["bgcoords"] = {0,0.625,0.33203125,0.498046875}, --left, right, top, bottom
--		["testfunc"] = function() return "GarrisonMissionAlertSystem:AddAlert("..GetFirstGarrisonMission(LE_FOLLOWER_TYPE_GARRISON_7_0, LE_FOLLOWER_TYPE_GARRISON_6_0)..")" end 
	},

	["GarrisonShipMissionAlertSystem"]= 
	{
		["bgname"] = "Interface\\Garrison\\GarrisonToast",
		["bgcoords"] = {0,0.625,0.33203125,0.498046875}, --left, right, top, bottom
		--["testfunc"] = function() return "GarrisonShipMissionAlertSystem:AddAlert("..GetFirstShipyardFollowerID()..")" end 
	},

	["GarrisonRandomMissionAlertSystem"]= {},
	["GarrisonFollowerAlertSystem"]= {},
	["GarrisonShipFollowerAlertSystem"]= {},
	["GarrisonTalentAlertSystem"]= {},
	["WorldQuestCompleteAlertSystem"]= 
	{
		["bgname"] = "Interface\\Icons\\Achievement_Quests_Completed_TwilightHighlands",
		["bgcoords"] = {0, 1, 0, 1}, --left, right, top, bottom
	},
	["LegendaryItemAlertSystem"]= {},
	["NewPetAlertSystem"]= {},
	["NewMountAlertSystem"]= {},

	["AchievementAlertSystem"] =
	{
		["bgname"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-Alert-Background",
		["bgcoords"] = {0, 0.605, 0, 0.703}, --left, right, top, bottom
	},
	["CriteriaAlertSystem"] = {},
	["LootAlertSystem"] = {},
	["LootUpgradeAlertSystem"] = {},
	["MoneyWonAlertSystem"] =
	{
		["bgname"] = "Interface\\LootFrame\\LootToast",
		["bgcoords"] = {0.56347656,0.80664063,0.28906250,0.56640625},
		["testfunc"] = function() return "MoneyWonAlertSystem:AddAlert(815)" end
	},
	["HonorAwardedAlertSystem"] = {},
	["NewRecipeLearnedAlertSystem"] = {},
}

local hookedAlerts = {}
	
function ADDON:PLAYER_LOGIN()
	ADDON:Debug("PLAYER_LOGIN")

	--Init LibDataBroker
	ADDON:InitLDB()

	ADDON:Debug("IniFrames..")

	for alert,sdata in ADDON:pairsByKeys(handledAlerts) do
		local data = {}
		data.sdata = sdata
		data.systemname = alert
		data.linenum = nil
		data.name = string.gsub(alert,"System","")
		ADDON:CreateSystemFrame(data)
		table.insert(hookedAlerts,data)
	end

end

function ADDON:PLAYER_LOGOUT()
	ADDON:Debug("PLAYER_LOGOUT")
	Broker_AlertFrames[GetRealmName()] = ADDON.save
end

-------------------------------------------------------------------------------
-- Broker Functions                                                        --
--------------------------------------------------------------------------------

function ADDON:InitLDB()
	--Create LDB
	ADDON.dataobj = ADDON.LDB:NewDataObject(ADDON.name,
	{
		type = "data source",
		icon = "Interface\\Icons\\Ability_Creature_Cursed_04",
		text = ADDON.L["alertframes"],
		label = ADDON.L["alertframes"],
		OnEnter = function(self)
			ADDON:Broker_OnEnter(self)
		end,
		OnLeave = function(self)
			ADDON:Broker_OnLeave(self)
		end,
		OnClick = function(frame,button)
			ADDON:Broker_OnClick(frame,button)
		end,
	})
end

function ADDON:Broker_OnEnter(brokerframe)
	--ADDON:Debug("Broker_OnEnter")
	if InCombatLockdown() then return end
	 ADDON:CreateTooltip()
	 ADDON.tooltip:Clear()
	 ADDON.tooltip:SmartAnchorTo(brokerframe)
	 ADDON.tooltip:SetAutoHideDelay(0.1, brokerframe)
	 ADDON:ShowTooltip()
end

function ADDON:Broker_OnLeave(brokerframe)
	--ADDON:Debug("Broker_OnLeave")
end

local show = false;

function ADDON:Broker_OnClick(brokerframe,button)
	if InCombatLockdown() then return end

	ADDON:Debug("Broker_OnClick")
end

function ADDON:CreateSystemFrame(systemdata)

	local system = _G[systemdata.systemname]	--check exitst
	if not system then return end
	ADDON:Debug("Creating and Hook Anchor:"..systemdata.systemname)

	local frame = CreateFrame("Frame", systemdata.systemname.."_Anchor", UIParent)

	frame:SetFrameStrata("DIALOG")
	frame:SetWidth(340)
	frame:SetHeight(100)
	frame:SetPoint("CENTER",0,0)

	frame:EnableMouse(true)
	frame:SetMovable(true)

	frame:SetScript("OnMouseDown",function(self, button)
		if button == "LeftButton" then
			self.isMoving = true
			self:StartMoving()
		else
			self:Hide()
		end
		
	end)

	frame:SetScript("OnMouseUp",function(self)
		if( self.isMoving ) then
			self.isMoving = nil
			self:StopMovingOrSizing()

			ADDON:SaveFrameData(self:GetName())
		end
	end)

	local stringA = frame:CreateFontString()
	stringA:SetAllPoints(frame)
	stringA:SetFontObject("GameFontNormalLarge")
	stringA:SetText(colorYellow..systemdata.name..colorOrange.."\n\n"..L["drag"])

	frame:SetBackdrop({
			-- bgFile="Interface\\ChatFrame\\ChatFrameBackground",
			-- edgeFile="Interface\\ChatFrame\\ChatFrameBackground",
			-- tile=true,
			-- tileSize=5,
			-- edgeSize= 2,

			bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
			tile = true, tileSize = 16, edgeSize = 16, 
			insets = { left = 4, right = 4, top = 4, bottom = 4 }

			-- bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background",  
			-- edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border",
			-- tile = true,
			-- tileSize = 32,
			-- edgeSize = 32,
			-- insets = {left = 11,right = 12,top = 12, bottom = 11} 
		})
	frame:SetBackdropColor(1,1,1,0.2)
	frame:SetBackdropBorderColor(1,0,0,1)

	frame.bg = frame:CreateTexture(nil, "BACKGROUND")
	frame.bg:SetAllPoints(true)

	if (systemdata.sdata.bgname) then
		frame.bg:SetTexture(systemdata.sdata.bgname)
		frame.bg:SetTexCoord(systemdata.sdata.bgcoords[1],systemdata.sdata.bgcoords[2],systemdata.sdata.bgcoords[3],systemdata.sdata.bgcoords[4])
	else
		frame.bg:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Background")
		frame.bg:SetTexCoord(0,1,0,1)
	end

	if (systemdata.sdata.testfunc) then
		local button = CreateFrame("Button", systemdata.systemname.."_BUtton", frame, "SecureActionButtonTemplate");
		button:SetWidth(64)
		button:SetHeight(24)
		button:SetPoint("LEFT", frame, "RIGHT", 0, 0);
		button:SetAttribute("type", "macro");
		ADDON:Debug("macrotext:"..systemdata.sdata.testfunc())
		button:SetAttribute("macrotext","/run "..systemdata.sdata.testfunc());

		button:SetText("test")
		button:SetNormalFontObject("GameFontNormalSmall")
		
		local ntex = button:CreateTexture(nil,"BORDER")
		ntex:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
		ntex:SetTexCoord(0, 0.625, 0, 0.6875)
		ntex:SetAllPoints()	
		button:SetNormalTexture(ntex)
		
		local htex = button:CreateTexture(nil,"BORDER")
		htex:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
		htex:SetTexCoord(0, 0.625, 0, 0.6875)
		htex:SetAllPoints()
		button:SetHighlightTexture(htex)
		
		local ptex = button:CreateTexture(nil,"BORDER")
		ptex:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
		ptex:SetTexCoord(0, 0.625, 0, 0.6875)
		ptex:SetAllPoints()
		button:SetPushedTexture(ptex)
	end

	frame:Hide()

	hooksecurefunc(system,"AdjustAnchors",function(self,...)

		local relativeAlert = frame

		if self.alertFrame then	--handle simple alert
			self.alertFrame:ClearAllPoints()
			self.alertFrame:SetPoint("CENTER", relativeAlert, "CENTER", 0, 0)
		elseif self.anchorFrame then	--handle anchored
			self.anchorFrame:ClearAllPoints()
			self.anchorFrame:SetPoint("CENTER", relativeAlert, "CENTER", 0, 0) --SetPoint("BOTTOM", relativeAlert, "TOP", 0, 10);
		elseif self.alertFramePool then	--handle multiple
			local first = true
			for alertFrame in self.alertFramePool:EnumerateActive() do
				alertFrame:ClearAllPoints()
				if first then
					first = false
					alertFrame:SetPoint("CENTER", relativeAlert, "CENTER", 0, 0);
				else
					alertFrame:SetPoint("BOTTOM", relativeAlert, "TOP", 0, 10);
				end
				relativeAlert = alertFrame;
			end
		end
	end)

	ADDON:RestoreFrameData(frame:GetName())

	systemdata["frame"] = frame
end

function ADDON:SaveFrameData(frame)
	if type(frame) ~= "string" then return end
	if not _G[frame] then return end
	
	local data = ADDON.save[frame] or 
	{
		["point"] = "CENTER",
		["relativePoint"] = "CENTER",
		["xOfs"] = 0,
		["yOfs"] = 0,
	}

	local point, relativeTo, relativePoint, xOfs, yOfs = _G[frame]:GetPoint()
	data.point = point
	data.relativePoint = relativePoint
	data.xOfs = xOfs
	data.yOfs = yOfs
	
	ADDON.save[frame] = data
end

function ADDON:RestoreFrameData(frame)
	if type(frame) ~= "string" then return end
	if not _G[frame] then return end

	local data = ADDON.save[frame] or nil
	if data then
		_G[frame]:ClearAllPoints()
		_G[frame]:SetPoint(data.point, UIParent, data.relativePoint, data.xOfs, data.yOfs)
	end
end

--------------------------------------------------------------------------------
-- ToolTip Functions                                                                  --
--------------------------------------------------------------------------------

function ADDON:DecimalToHex(r,g,b)
    return string.format("|cff%02x%02x%02x", r*255, g*255, b*255)
end

function ADDON:CreateTooltip()
	--ADDON:Debug("CreateTooltip")
	local tooltip = ADDON.QTip:Acquire(ADDON.name.."Tooltip", 2, "LEFT", "RIGHT")
	ADDON.tooltip = tooltip
end

function ADDON:DestroyTooltip()
	--ADDON:Debug("DestroyTooltip")
	if ADDON.tooltip then
		ADDON.QTip:Release(ADDON.tooltip)
		ADDON.tooltip = nil
	end
end


function ADDON:IsVisibleAny()
	local visibleall = false
	for _,data in pairs(hookedAlerts) do
		if (data.visible) then visibleall = true end
	end
	return visibleall
end
	

--Main Tooltip
function ADDON:ShowTooltip()
	--ADDON:Debug("ShowTooltip")

	ADDON.tooltip:Clear()
	ADDON.tooltip:AddHeader(ADDON.name)

	ADDON.tooltip:AddSeparator()

	local visibleall = ADDON:IsVisibleAny()
	local line = ADDON.tooltip:AddLine(colorYellow..L["toggle"],visibleall and colorGreen..L["shown"] or colorRed..L["hidden"])
	ADDON.tooltip:SetLineScript(line,"OnMouseUp",function(var) 
			visibleall = not visibleall
			for _,data in pairs(hookedAlerts) do
				data.visible = visibleall
				data.frame:SetShown(visibleall)
				ADDON.tooltip:SetCell(data.linenum,2,data.visible and colorGreen..L["shown"] or colorRed..L["hidden"])
			end
			ADDON.tooltip:SetCell(line,2,visibleall and colorGreen..L["shown"] or colorRed..L["hidden"])
		end)

	ADDON.tooltip:AddSeparator()

	for _,data in pairs(hookedAlerts) do
		data.linenum = ADDON.tooltip:AddLine(colorYellow..data.name,data.frame:IsShown() and colorGreen..L["shown"] or colorRed..L["hidden"])
		ADDON.tooltip:SetLineScript(data.linenum,"OnMouseUp",function(var) 
			data.visible = not data.visible
			data.frame:SetShown(data.visible)
			ADDON.tooltip:SetCell(data.linenum,2,data.frame:IsShown() and colorGreen..L["shown"] or colorRed..L["hidden"])
			ADDON.tooltip:SetCell(line,2,ADDON:IsVisibleAny() and colorGreen..L["shown"] or colorRed..L["hidden"])
		 end)
	end

	ADDON.tooltip:Show()
end

